import {
  Metadata, IDictionary, IEventParam,
} from '@zeedhi/core';
import {
  Select, Row,
} from '@zeedhi/common';

export class TarefasController {
  public list: IDictionary = [];

  public listCardTarefa: IDictionary = [];

  get andar() {
    const selectObject = Metadata.getInstance<Select>('selectAndar');
    return selectObject.value || '*';
  }

  get horario() {
    const selectObject = Metadata.getInstance<Select>('selectHorario');
    return selectObject.value || '*';
  }

  get tarefa() {
    const selectObject = Metadata.getInstance<Select>('selectTarefa');
    return selectObject.value || '*';
  }

  public cards() {
    return {
      name: 'colHora',
      component: 'ZdCol',
      children: [
        {
          name: 'tarefaCard',
          component: 'ZdCard',
          cssClass: 'zd-mb-4',
          children: [
            {
              name: 'row-result',
              component: 'ZdRow',
              children: [
                {
                  name: 'colHora',
                  component: 'ZdCol',
                  cols: '3',
                  cssClass: 'zd-display-flex zd-my-2 zd-pa-1 zd-align-center',
                  children: [
                    {
                      name: 'card',
                      component: 'ZdText',
                      text: '<span style="font-weight:bolder; font-size: 18px;">09:30</span>',
                      cssClass: 'zd-my-auto',
                    },
                  ],
                },
                {
                  name: 'colDescricao',
                  component: 'ZdCol',
                  cols: '7',
                  children: [
                    {
                      name: 'linha',
                      component: 'ZdText',
                      text: '<span  style="background-color:lightgrey; color: red; font-size: 12px;">ATRASADO</span>',
                    },
                    {
                      name: 'linha',
                      component: 'ZdText',
                      text: 'Limpeza concorrente',
                    },
                    {
                      name: 'linha',
                      component: 'ZdText',
                      text: '<span style="font-size: 22px; font-weight:bolder;">Sala 005</span>',
                    },
                    {
                      name: 'linha',
                      component: 'ZdText',
                      text: 'Bloco 1 / Andar 1',
                    },
                  ],
                },
                {
                  name: 'colIcone',
                  component: 'ZdCol',
                  cols: '2',
                  children: [
                    {
                      name: 'card',
                      component: 'ZdText',
                      text: 'mdi-toilet',
                      tag: 'v-icon',
                    },
                  ],
                },
              ],
            },
          ],
        },
      ],
    };
  }

  public cards2() {
    return {
      name: 'colHora',
      component: 'ZdCol',
      children: [
        {
          name: 'tarefaCard',
          component: 'ZdCard',
          cssClass: 'zd-mb-4',
          children: [
            {
              name: 'row-result',
              component: 'ZdRow',
              children: [
                {
                  name: 'colHora',
                  component: 'ZdCol',
                  cols: '3',
                  cssClass: 'zd-display-flex zd-my-2 zd-pa-1 zd-align-center',
                  children: [
                    {
                      name: 'card',
                      component: 'ZdText',
                      text: '<span style="font-weight:bolder; font-size: 18px;">10:00</span>',
                      cssClass: 'zd-my-auto',
                    },
                  ],
                },
                {
                  name: 'colDescricao',
                  component: 'ZdCol',
                  cols: '7',
                  children: [
                    {
                      name: 'linha',
                      component: 'ZdText',
                      text: '<span  style="background-color:lightgrey; color: green; font-size: 12px;">FINALIZADO</span>',
                    },
                    {
                      name: 'linha',
                      component: 'ZdText',
                      text: 'Limpeza concorrente',
                    },
                    {
                      name: 'linha',
                      component: 'ZdText',
                      text: '<span style="font-size: 22px; font-weight:bolder;">Banheiro 005</span>',
                    },
                    {
                      name: 'linha',
                      component: 'ZdText',
                      text: 'Bloco 1 / Andar 1',
                    },
                  ],
                },
                {
                  name: 'colIcone',
                  component: 'ZdCol',
                  cols: '2',
                  children: [
                    {
                      name: 'card',
                      component: 'ZdText',
                      text: 'mdi-toilet',
                      tag: 'v-icon',
                    },
                  ],
                },
              ],
            },
          ],
        },
      ],
    };
  }

  public cards3() {
    return {
      name: 'colHora',
      component: 'ZdCol',
      children: [
        {
          name: 'tarefaCard',
          component: 'ZdCard',
          cssClass: 'zd-mb-4',
          children: [
            {
              name: 'row-result',
              component: 'ZdRow',
              children: [
                {
                  name: 'colHora',
                  component: 'ZdCol',
                  cols: '3',
                  cssClass: 'zd-display-flex zd-my-2 zd-pa-1 zd-align-center',
                  children: [
                    {
                      name: 'card',
                      component: 'ZdText',
                      text: '<span style="font-weight:bolder; font-size: 18px;">10:00</span>',
                      cssClass: 'zd-my-auto',
                    },
                  ],
                },
                {
                  name: 'colDescricao',
                  component: 'ZdCol',
                  cols: '7',
                  children: [
                    {
                      name: 'linha',
                      component: 'ZdText',
                      text: '<span  style="background-color:lightgrey; color: blue; font-size: 12px;">EM ANDAMENTO</span>',
                    },
                    {
                      name: 'linha',
                      component: 'ZdText',
                      text: 'Limpeza concorrente',
                    },
                    {
                      name: 'linha',
                      component: 'ZdText',
                      text: '<span style="font-size: 22px; font-weight:bolder;">Consutório 001</span>',
                    },
                    {
                      name: 'linha',
                      component: 'ZdText',
                      text: 'Bloco 1 / Andar 1',
                    },
                  ],
                },
                {
                  name: 'colIcone',
                  component: 'ZdCol',
                  cols: '2',
                  children: [
                    {
                      name: 'card',
                      component: 'ZdText',
                      text: 'mdi-toilet',
                      tag: 'v-icon',
                    },
                  ],
                },
              ],
            },
          ],
        },
      ],
    };
  }

  public criarCard() {
    const componente = Metadata.getInstance<Row>('localCard');
    componente.children.push(this.cards());
  }

  public getParent(component: IEventParam<any>, nameComponent: string): any {
    if (component.component === nameComponent) {
      return component;
    }
    if (component.parent) {
      return this.getParent(component.parent, nameComponent);
    }
    return null;
  }
}
