import Vue from 'vue';
import Router from 'vue-router';
import { ZdPage } from '@zeedhi/vue';

Vue.use(Router);

const router = new Router({
  mode: 'history',
  base: process.env.BASE_URL,
  routes: [
    {
      path: '/',
      name: 'home',
      component: () => import('./views/Home.vue'),
    },
    {
      path: '/zeedhi',
      name: 'zeedhi',
      component: ZdPage,
      props: () => ({
        path: 'zeedhi',
        local: true,
      }),
    },
    {
      path: '/ListaTarefas',
      name: 'ListaTarefas',
      component: ZdPage,
      props: () => ({
        path: 'listaTarefas',
        local: true,
      }),
    },
    {
      path: '/Lista',
      name: 'Lista',
      component: ZdPage,
      props: () => ({
        path: 'lista',
        local: true,
      }),
    },
    {
      path: '/Teste',
      name: 'Teste',
      component: ZdPage,
      props: () => ({
        path: 'teste',
        local: true,
      }),
    },
    {
      path: '/login',
      name: 'login',
      component: ZdPage,
      props: () => ({
        path: 'login',
        local: true,
      }),
    },
    {
      path: '*',
      component: ZdPage,
      props: {
        path: 'notfound',
        local: true,
      },
    },
  ],
});

export default router;
